<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-133"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FGeneral%2FCategory%2FNSString%2BPasswordStrength.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/General/Category/NSString+PasswordStrength.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d53dd88e59abdcd55a12c7e475393fb.html">General</a></li><li class="navelem"><a class="el" href="dir_6aab43a226a6a6887d476b2e5d48e49d.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">NSString+PasswordStrength.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_n_s_string_09_password_strength_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="category_n_s_string_07_password_strength_08.html#aa5d42c997ccee6fafb4dfef49be0babe">    1</a></span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  NSString+PasswordStrength.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by zahir on 2017/7/18.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_n_s_string_09_password_strength_8h.html">NSString+PasswordStrength.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_n_s_string_07_password_strength_08.html">NSString (PasswordStrength)</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;<span class="comment">//条件</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;- (NSString *)<a class="code" href="category_n_s_string_07_password_strength_08.html#aa5d42c997ccee6fafb4dfef49be0babe">judgePasswordStrength</a></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;{</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;    NSMutableArray *resultArray = [[NSMutableArray alloc] init];</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;    NSArray *termArray1 = [[NSArray alloc] initWithObjects:@&#34;a&#34;, @&#34;b&#34;, @&#34;c&#34;, @&#34;d&#34;, @&#34;e&#34;, @&#34;f&#34;, @&#34;g&#34;, @&#34;h&#34;, @&#34;i&#34;, @&#34;j&#34;, @&#34;k&#34;, @&#34;l&#34;, @&#34;m&#34;, @&#34;n&#34;, @&#34;o&#34;, @&#34;p&#34;, @&#34;q&#34;, @&#34;r&#34;, @&#34;s&#34;, @&#34;t&#34;, @&#34;u&#34;, @&#34;v&#34;, @&#34;w&#34;, @&#34;x&#34;, @&#34;y&#34;, @&#34;z&#34;, @&#34;A&#34;, @&#34;B&#34;, @&#34;C&#34;, @&#34;D&#34;, @&#34;E&#34;, @&#34;F&#34;, @&#34;G&#34;, @&#34;H&#34;, @&#34;I&#34;, @&#34;J&#34;, @&#34;K&#34;, @&#34;L&#34;, @&#34;M&#34;, @&#34;N&#34;, @&#34;O&#34;, @&#34;P&#34;, @&#34;Q&#34;, @&#34;R&#34;, @&#34;S&#34;, @&#34;T&#34;, @&#34;U&#34;, @&#34;V&#34;, @&#34;W&#34;, @&#34;X&#34;, @&#34;Y&#34;, @&#34;Z&#34;, nil];</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;    NSArray *termArray2 = [[NSArray alloc] initWithObjects:@&#34;1&#34;, @&#34;2&#34;, @&#34;3&#34;, @&#34;4&#34;, @&#34;5&#34;, @&#34;6&#34;, @&#34;7&#34;, @&#34;8&#34;, @&#34;9&#34;, @&#34;0&#34;, nil];</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;    NSArray *termArray3 = [[NSArray alloc] initWithObjects:@&#34;~&#34;,@&#34;`&#34;,@&#34;@&#34;,@&#34;#&#34;,@&#34;$&#34;,@&#34;%&#34;,@&#34;^&#34;,@&#34;&amp;&#34;,@&#34;*&#34;,@&#34;(&#34;,@&#34;)&#34;,@&#34;-&#34;,@&#34;_&#34;,@&#34;+&#34;,@&#34;=&#34;,@&#34;{&#34;,@&#34;}&#34;,@&#34;[&#34;,@&#34;]&#34;,@&#34;|&#34;,@&#34;:&#34;,@&#34;;&#34;,@&#34;&ldquo;&#34;,@&#34;&#39;&#34;,@&#34;&lsquo;&#34;,@&#34;&lt;&#34;,@&#34;,&#34;,@&#34;.&#34;,@&#34;&gt;&#34;,@&#34;?&#34;,@&#34;/&#34;,@&#34;、&#34;, nil];</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;    </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;    NSString *result1 = [NSString stringWithFormat:@&#34;%d&#34;,[NSString judgeRange:termArray1 Password:self]];</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;    NSString *result2 = [NSString stringWithFormat:@&#34;%d&#34;,[NSString judgeRange:termArray2 Password:self]];</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    NSString *result3 = [NSString stringWithFormat:@&#34;%d&#34;,[NSString judgeRange:termArray3 Password:self]];</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;    </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;    [resultArray addObject:[NSString stringWithFormat:@&#34;%@&#34;,result1]];</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;    [resultArray addObject:[NSString stringWithFormat:@&#34;%@&#34;,result2]];</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    [resultArray addObject:[NSString stringWithFormat:@&#34;%@&#34;,result3]];</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;    </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;    <span class="keywordtype">int</span> intResult = 0;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; [resultArray count]; j++)</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;    {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;        <span class="keywordflow">if</span> ([[resultArray objectAtIndex:j] isEqualToString:<span class="stringliteral">@&#34;1&#34;</span>])</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;        {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;            intResult++;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;        }</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;    }</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    NSString *resultString = [[NSString alloc] init];</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;    <span class="keywordflow">if</span> (intResult == 2)</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;    {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;        <span class="comment">//密码强度中</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;        resultString = <span class="stringliteral">@&#34;2&#34;</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;    } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (intResult == 3) {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;        <span class="comment">//密码强度高</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;        resultString = <span class="stringliteral">@&#34;3&#34;</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;        <span class="comment">//密码强度低，建议修改</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;        resultString = <span class="stringliteral">@&#34;1&#34;</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;    }</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    <span class="keywordflow">return</span> resultString;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;<span class="comment">//判断是否包含</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;+ (BOOL)judgeRange:(NSArray *)_termArray Password:(NSString *)_password</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    NSRange range;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    BOOL result =NO;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; [_termArray count]; i++)</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;    {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;        range = [_password rangeOfString:[_termArray objectAtIndex:i]];</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;        <span class="keywordflow">if</span> (range.location != NSNotFound)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;        {</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;            result = YES;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;        }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;    }</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;}</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="acategory_n_s_string_07_password_strength_08_html_aa5d42c997ccee6fafb4dfef49be0babe"><div class="ttname"><a href="category_n_s_string_07_password_strength_08.html#aa5d42c997ccee6fafb4dfef49be0babe">-[NSString(PasswordStrength) judgePasswordStrength]</a></div><div class="ttdeci">NSString * judgePasswordStrength()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_password_strength_8m_source.html#l00001">NSString+PasswordStrength.m:13</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_password_strength_08_html"><div class="ttname"><a href="category_n_s_string_07_password_strength_08.html">NSString(PasswordStrength)</a></div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_password_strength_8h_source.html#l00011">NSString+PasswordStrength.h:11</a></div></div>
<div class="ttc" id="a_n_s_string_09_password_strength_8h_html"><div class="ttname"><a href="_n_s_string_09_password_strength_8h.html">NSString+PasswordStrength.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>